--VERSION 0.0.11
--DATE 15 08 2014

--RECENT CHANGES
--reworked buttons in roll frame to react to index and generally be a bit smarter, merged button roll functions into a single function, fixed consecutive instances of loot window (still can´t do multiple simultaneous instances though)

--TO DO
-- always stuff to do... 

local RLRFrame=CreateFrame("Frame") -- creating  a frame for determining what the content of the loot roll frame is (probably unnecessary?)
RLRFrame:RegisterEvent("ADDON_LOADED"); -- Fired when saved variables are loaded
RLRFrame:RegisterEvent("PLAYER_LOGOUT"); -- Fired when about to log out
RLRFrame:RegisterEvent("PARTY_LOOT_METHOD_CHANGED"); -- Fired when about to log out
RLRFrame:RegisterEvent("RAID_ROSTER_UPDATE"); --Fired when about to log out
RLRFrame:RegisterEvent("CHAT_MSG_ADDON"); -- 
RLRFrame:SetScript("OnEvent", RLRFrame.OnEvent); --probably sets script so that when an event fires, the function below is ran?

function RLRFrame:OnEvent(event,arg1,arg2,arg3,arg4) -- function pertaining to the frame that checks addon being loaded (probably very wrong to do it like this)
 			
		if event == "ADDON_LOADED" and arg1 == "RankedLootRoll" then --checking that the addon being loaded is this one
			--message ("RLR main lua file v 0.0.5 loaded properly") --for some reason, message shows here, while print does not
			RegisterAddonMessagePrefix("RLR")
			RegisterAddonMessagePrefix("RLRReply")
			RegisterAddonMessagePrefix("RLRItemLink")
			print("Registered 4 prefixes")
			--ItemRollFrame:Hide()
			--print (event)
			--	if RLRSavedData == nil then -- for some reason, when I use print, it doesn´t show, but if I use message, it does
			--			print ("Setting RLRDataToSave to 0 since it is registering as nil")
			--			RLRSavedData = 0; -- setting it to 0 so that I can check if it saved after running it for the first time.
			--	else	 
			--		 -- TO BE IMPLEMENTED - print last entry from RLRSavedData
			--	end --end of if block checking RLRSavedData
		
		--elseif event == "CHAT_MSG_ADDON" then --and arg2 ~= "RLRReply" then
		--	print("RLR report: event= ",event,",arg1= ",arg1,",arg2=",arg2,",arg3=",arg3,",arg4=",arg4) --DEBUG
		
		elseif event == "PARTY_LOOT_METHOD_CHANGED" then
			print (event)
			--RLRFunctions.CheckLootMethod() 
		
		elseif event == "CHAT_MSG_ADDON" and arg1 == "RLRReply" then
		print("|cFF00FF00",arg2)
		--RLRFunctions.ReceiveReply(arg1,arg2,arg3,arg4) -DEBUG, CURRENTLY NOT DOING ANYTHING USEFUL, CAN DELETE
			
		elseif event == "CHAT_MSG_ADDON" and arg1 == "RLRItemLink" then
		--print("Debugging CHAT_MSG_ADDON event handler in RankedLootRoll.lua: arg2=",arg2)
		print("RLR message: Anyone calling dibs on :",arg2,"?")
		RLRFunctions.ShowFrame(arg2)
		end --end of if block (if event == "ADDON_LOADED" and arg1 == "RankedLootRollML")
 		
end
--end of function RLRFrame


RLRFrame:SetScript("OnEvent", RLRFrame.OnEvent); -- this is not doing what I want it to do (which is to register the slash command) but if I take it away, the message at line 10 doesn´t fire
function SlashCmdList.rlr(msg, modifier)
print("registering slash command /rlr ");
SLASH_RLR = "/rlr";
message("registering slash command /rlr ");
end

-- TABLES GET DEFINED BELOW HERE
RLRFunctions = {} -- making a table for storing functions
RLRFunctionsSave=RLRFunctions
local RLRFunctions = RLRFunctions -- because of the tip that local functions are accessed faster (I still don´t understand how exactly this works though)
RLRSavedData = {}
RLRSavedData2 = {} -- probably going to implement this, then I will replace all RLRSavedData references with RLRSavedData2 (and change RLRSavedData2 to RLRSavedData
RollEntry = {}
RLRChannels={}
UISpecialFrames={}
RLRSessionLooted={}
-- TABLES GET DEFINED ABOVE HERE

	
-- FUNCTIONS GET DEFINED BELOW HERE

-- SLASH COMMAND FUNCTIONS

-- FUNCTIONS THAT DEAL WITH RLR COMM CHANNEL
function Strip(name) 
  return string.gsub(name, "%W", "")
end

CheckSum = function(text)
	local counter = 1
	local len = string.len(text)
	for i=1,len do
		counter = counter + string.byte(text, i)*math.pow(31, len- i)
	end
	counter = math.fmod(counter, 7919)
	return string.format("%06x", counter)
end

function RLRConcatRealmName(name,realm)
	if realm then name=strjoin ("-",name,realm)
	end
	--print ("RLR DEBUG:returning name for ConcatRealmName")
	return name
end

function RLRFunctions.CheckLootMethod() 
 -- TODO IN FUTURE - WHEN LOOT METHOD CHANGES, ASK WHETHER TO TURN ADDON ON. IF SO, SET SESSION VARIABLE WHICH OTHER EVENT CHECKS IN HANDLER WOULD CHECK BEFORE FIRING 
	local lootmethod=GetLootMethod()
			if not IsInGroup(Player) then --IF NOT IN GROUP, do nothing
			print ("not in group")
			end
			if lootmethod=="master" then --IF IN GROUP, JOIN THE RLR/RLRML COMM CHANNEL
			print("Joining RLR/RLRML communication channel") --DEBUG
			RLRFunctions.Channel()
			end
end 

function RLRFunctions.ShowFrame(message)
--print("RLR debug line 113 - showframe: message=",message)
local LootSpecs=message
local index,lootIcon,itemlink=strsplit(".",message)
--tinsert (RLRSessionLooted,index)
print("RLR debug - lootIcon=",lootIcon)
print("RLR debug - itemlink=",itemlink)
print("RLR debug - index=",index)
local framenamejoined=strjoin("_","RLRLoot",index)
local FrameName = CreateFrame("frame",framenamejoined,UIParent,"RollFrame")
_G[framenamejoined.."ItemName"]:SetText(itemlink)
_G[framenamejoined.."IconOfLootItem"]:SetTexture(lootIcon)
print(framenamejoined)
end

 function RLRFunctions.GetMLName()
 local lootmethod, masterlooterPartyID, masterlooterRaidID = GetLootMethod()
		
		if UnitInParty("Player") == nil then
	--	print ("Not in a party, sending RLRML comm to self")
		RLRName=UnitName("Player")
		
		elseif masterlooterRaidID ~= nil then --I´m in a raid, everything seems to work as intended
		RLRName = GetRaidRosterInfo(masterlooterRaidID)
	--	print ("RLR DEBUG: GETMLName name= ",name)

		elseif masterlooterRaidID == nil and masterlooterPartyID == 0 and lootmethod == "master" then -- I´m not in a raid and ML is probably myself
		RLRName = GetUnitName("Player")
	--	print ("RLR DEBUG: GETMLName name= ",name)
		
		elseif masterlooterRaidID == nil and masterlooterPartyID ~= 0 and lootmethod == "master" then -- I´m not in a raid, I AM in a party with the masterlooter and ML is probably not myself?
		local temp = strjoin ("","Party",masterlooterPartyID)
	--	print(temp)
		RLRName, RLRrealm = UnitName(temp,true)
		RLRName=RLRConcatRealmName(RLRname,RLRrealm)
	-- still not showing realm name though
	-- print ("RLR DEBUG: GETMLName name=",RLRname)
		
		elseif lootmethod ~= "master" then
	--	print ("not using master looter")
		RLRname=UnitName("Player")
		end
	
	--print ("RLRFunctions.GetMLName from RankedLootRoll.lua - RLRName=",RLRName)
	return RLRName
	end
	 
 function RLRFunctions.Channel() -- Takes care of creating/joining channel for communication between RLRML and RLR
	RLRName=RLRFunctions.GetMLName()
	print("working at line 150, RLRName=",RLRName)
	if RLRName then
	local cname=RLRName	
	local cs = CheckSum(cname) -- cleaning the loot master name and adding checksum to create unique channel name
	local cname = Strip(cname)
	local cname = string.sub(cname, 1, 8)
	GroupChannelName = ("RLR" .. cname .. cs)
	print ("RLR and RLRML communication channel is called", GroupChannelName)
	SendAddonMessage("RLR",GroupChannelName,"RAID" );
	--SendChatMessage(GroupChannelName, "GUILD", nil) --debug, just checking if it works, remove later
	print("Group channel name=",GroupChannelName)
	print("whisper target name=",RLRName)
	-- now join the channel if I´m not already in it
	if GetChannelName(GroupChannelName) == 0 then
		for index,value in ipairs(RLRChannels) do 
		LeaveChannelByName(value)
		print ("Leaving",value)
		end
	wipe(RLRChannels)
	print ("joining channel ",GroupChannelName)
	JoinChannelByName(GroupChannelName)
	tinsert(RLRChannels, GroupChannelName)
	else -- else tell me I´m already in
		print ("already in the channel")
		tinsert(RLRChannels, GroupChannelName)
		for index,value in ipairs(RLRChannels) do -- attempting a tempting thing
			LeaveChannelByName(value)-- attempting a tempting thing
			print ("Leaving",value) -- attempting a tempting thing
			end -- attempting a tempting thing
	end
	end
end
 
function RLRFunctions.ReceiveReply(arg1,arg2,arg3,arg4) --CURRENTLY DOESN´T DO ANYTHING USEFUL, BUT I WILL KEEP IT AROUND IN CASE I WANT TO EXPAND IT LATER
-- print ("received message with the following args", arg1,arg2,arg3,arg4)
end

function RLRFunctions.OptionsPanel(...) -- RLR Options panel
   message('loading rlr options');
end

function RLRFunctions.History(...) -- RLR History panel
   print ("Last record from the previous session: " .. RLRDataToSave .. "");
   SendAddonMessage("RLR",GroupChannelName, "RAID" );
end


function RLRFunctions.Test(msg,par1,par2,par3)
print("DEBUG: no function in RLR is currently assigned for testing ")
end

function RLRFunctions.Roll(rolltype,index,lootIcon,itemlink) -- RLR Major Roll
--  print('RLR DEBUG: performing a major upgrade roll')
print ("RLR DEBUG 217: LootMessage=",index,lootIcon,itemlink)
	local RLRName=RLRFunctions.GetMLName()
	print ("RLR DEBUG line 219-Roll. rolltype=",rolltype)
	local message=strjoin("_",rolltype,index)
	SendAddonMessage("RLRRoll",message,"WHISPER",RLRName)
	--SendChatMessage("RLRRollMajor","WHISPER","COMMON",RLRName); -- DEBUG, JUST TO SEE IT´S GETTING THROUGH, REMOVE LATER
  end
  
    
function RLRFunctions.SavedData(...) -- RLR printing the contents of the table "RLRFunctions"
  print ("printing the contents of the table RLRSavedData");
  table.foreach(RLRSavedData, print) -- Prints the whole table, going to remove this soon
 print ("");
 print ("Now printing the last entry once more, for good measure");
  local RLRTableLength = table.getn(RLRSavedData2); -- find the size of the table 
  local printlastentry = tostring (RLRSavedData2,RLRTableLength)
  print(printlastentry); -- prints the last entry from the table, but it needs to be converted to string first
  end
-- FUNCTIONS ARE DEFINED ABOVE HERE
	


	
--WORK IN PROGRESS - SLASH COMMAND
SLASH_RLR1, SLASH_RLR2 = '/rlr', '/RLR'; 
function SlashCmdList.RLR(msgfull, editbox)--, editbox)
local msg,par1,par2,par3=strsplit(" ",msgfull)
local msg=strlower(msg)
 if msg == 'history' then
RLRFunctions.History();
 elseif msg == 'roll' then
RLRFunctions.Roll();
elseif msg == 'test' then
RLRFunctions.Test(msg,arg1,arg2,arg3)
elseif msg == 'saveddata' then
RLRFunctions.SavedData();
elseif msg == "showframe" then
RLRFunctions.ShowFrame()
elseif string.find(msg, "tableinsert") ~=  nil then -- if argument contains tableinsert, I want to insert the second argument
--ar1, ar2, ar3 =(string.split(" ",msg,3)); -- apparently this can parse the msg into individual words separated by space if I use print, but not to set arguments
local RLRArgument = { strsplit(" ",msg,3)}
   print(msg)
   RLRFunctions.TableInsert(ar1,ar2,ar3); -- not working at the moment, ar1, ar2 and ar3 are nil
 else
 print("Raid Loot Roll has the following arguments");
  print("/rlr history for records history");
 print("/rlr major to perform a major upgrade roll");
 print("/rlr tableinsert [modifier] to test inserting stuff into table RLRSavedData");
 print("/rlr saveddata to test inserting stuff into table RLRSavedData");
 end
end
--WORK IN PROGRESS - SLASH COMMAND


local RLRLootFrame = CreateFrame("Frame") -- creating  a second frame for determining what the content of the loot roll frame is (probably unnecessary?)
RLRLootFrame:RegisterEvent("START_LOOT_ROLL")
RLRLootFrame:SetScript("OnEvent",   function (self, event, ...)
	local RLRRollNumber = math.random(100);
	local texture, name, count, quality = GetLootRollItemInfo (...)	
	local RLRRollNumberString = tostring(RLRRollNumber);
	local RollEntry = {}
	if i==nil then i=0;
	end
	i = i+1;
	RollEntry[i] = {}
	RollEntry[i].RLRUnitName = GetUnitName("player");
	RollEntry[i].RLRollNumberString = RLRRollNumberString;
	RollEntry[i].Name = name;
	RollEntry[i].Date = date();
	print("Printing table RollEntry");
	table.foreach(RollEntry[i], print) -- Prints the whole table, going to remove this soon
	tinsert(RLRSavedData, strjoin("", GetUnitName("player"), " rolled ", RLRRollNumberString," on " ,name," on ",date()));
	print("Printing table RLRSavedData entry, which is the old way of saving stuff as a string");
	print(strjoin("", GetUnitName("player"), " rolled ", RLRRollNumberString," on " ,name," on ",date()));
	tinsert(RLRSavedData2, RollEntry[i]); -- save the RollEntry[i] into RLRSavedData2, (I wasn´t able to figure out how to do it with RollEntry, no matter how I wrote it, it wouldn´t save)
	end)